import javafx.application.Application; 
import javafx.scene.Group; 
import javafx.scene.Scene; 
import javafx.scene.paint.Color; 
import javafx.scene.shape.Rectangle; 
import javafx.scene.transform.Rotate; 
import javafx.scene.transform.Scale; 
import javafx.scene.transform.Translate; 
import javafx.stage.Stage; 
import javafx.scene.shape.Polygon; 
         
public class FXPolygon extends Application { 
   @Override 
   public void start(Stage stage) { 


    Polygon polygon = new Polygon(); 

    //Adding coordinates to the polygon 
    polygon.getPoints().addAll(new Double[]{ 
        200.0, 50.0, 
        400.0, 50.0, 
        450.0, 150.0,          
        400.0, 250.0, 
        200.0, 250.0,                   
        150.0, 150.0, 
     }); 

      //creating the rotation transformation 
      Rotate rotate = new Rotate(); 
      
      //Setting the angle for the rotation 
      rotate.setAngle(20); 
      
      //Setting pivot points for the rotation 
      rotate.setPivotX(150); 
      rotate.setPivotY(225); 
       
      //Creating the scale transformation 
      Scale scale = new Scale(); 
      
      //Setting the dimensions for the transformation 
      scale.setX(1.5); 
      scale.setY(1.5); 
      
      //Setting the pivot point for the transformation 
      scale.setPivotX(300); 
      scale.setPivotY(135); 
       
      //Creating the translation transformation 
      Translate translate = new Translate();       
      
      //Setting the X,Y,Z coordinates to apply the translation 
      translate.setX(10); 
      translate.setY(0); 
      translate.setZ(0); 

       
      //Adding all the transformations to the polygon
      polygon.getTransforms().addAll(rotate, scale, translate); 
     
        
      //Creating a Group object  
      Group root = new Group(polygon); 
      
      //Creating a scene object 
      Scene scene = new Scene(root, 600, 300);  
      
      //Setting title to the Stage 
      stage.setTitle("Multiple transformations"); 
         
      //Adding scene to the stage 
      stage.setScene(scene); 
         
      //Displaying the contents of the stage 
      stage.show(); 
   }      
   public static void main(String args[]){ 
      launch(args); 
   } 
}